<head>
    <script src="//unpkg.com/d3"></script>
  
    <script src="//unpkg.com/treemap-chart"></script>
    <!--<script src="../../dist/treemap-chart.js"></script>-->

    <title> Anki source code treemap </title>
    <style>body { margin: 0 }</style>
  </head>
  <body>
    <div id="chart"></div>
  
    <script>
      const color = d3.scaleOrdinal(d3.schemePaired);
      // https://api.github.com/repos/ankitects/anki/git/trees/HEAD?per_page=100&recursive=1
      var url = "https://api.github.com/repos/ankitects/anki/git/trees/HEAD?per_page=100&recursive=1"
      fetch(url).then( res => res.json())
      // fetch('data.json').then( res => res.json())
      .then(data => {
        var dir = {"name": "anki"}
        var z = data.tree
        .filter(d => d.size)
        .filter(d => d.path.endsWith(".py") || d.path.endsWith(".rs"))
        .filter(d => !d.path.startsWith("qt/") || d.path.endsWith(".rs"))
        var addchild = (parent, path, obj) => {
          if(path.length==0){return} 
          var parts = path.split("/");  //build,ninja_gen,src,copy.rs
          parent.children = parent.children || []
          var item = parent.children.find( d => d.name == parts[0])
          if(!item){
            item = {"name": parts[0]};
            if(parts.length == 1){
              item.size = obj.size;
            }
            parent.children.push(item)
          }
          addchild(item, parts.slice(1).join("/"), obj)
        }
        z.forEach( d => addchild(dir, d.path, d))
        console.log(dir)
        Treemap()
          .data(dir)
          .label('name')
          .size('size')
          .excludeRoot(true)
          .color((d, parent) => color(parent ? parent.data.name : null))
          .tooltipContent((d, node) => `Size: <i>${node.value}</i>`)
          (document.getElementById('chart'));
      });

      
      // fetch('flare.json').then(res => res.json()).then(data => {
      //   console.log(data)
      //   Treemap()
      //     .data(data)
      //     .label('name')
      //     .size('size')
      //     .excludeRoot(true)
      //     .color((d, parent) => color(parent ? parent.data.name : null))
      //     .tooltipContent((d, node) => `Size: <i>${node.value}</i>`)
      //     (document.getElementById('chart'));
      // });
    </script>
  </body>